<?php
	require_once('../core/libraries/core.php');
	require_once('../core/settings.php');
	
	$obj = new Core($_dbSettings, $_settings);
	
	$_name = (empty($_POST['name'])) ? '' : trim($_POST['name']);
	$_type = (empty($_POST['type'])) ? 'first' : $_POST['type'];
	$_eid = (empty($_POST['eid'])) ? 0 : $_POST['eid'];
	
	//fail
	if(empty($_name)){ exit; }
	
	//make sure it's just from Cerebro student.
	$getStudent = $obj->getStudents($_eid);
	if(count($getStudent)==0){
		exit; 
	}
	else{
		$Student = $getStudent[0];
		if($_type == 'firstName'){
			$currentnameval = $Student->firstNamePronunciation;
		}
		elseif($_type == 'lastName'){
			$currentnameval = $Student->lastNamePronunciation;
		}
		else{
			exit;
		}
	}
	
	
	$filename = '/audio/en/tts-' . $Student->studentID . '-'. $_type .'.wav';	
	$t = time(); //cachekiller
	
	//make sure they didnt reach the limit.
	if((int)$Student->pronunciationAttempt > $obj->settings['watson_TTS_limit_per_person']){
		echo '<p>According to our error-free logs, you have reached your limit to use our "LISTEN" feature. We recommend you contact us at <a href="tel:'. $obj->settings['for_more_info_phone'] . '">' . $obj->settings['for_more_info_phone'] .'</a> or <a href="mailto:'. $obj->settings['rsvp_email'] .'">'. $obj->settings['rsvp_email'] .'</a></p>';
		exit;
	}
	
	if($currentnameval != $_name){
		$curl = curl_init();
		
		$modNameVal = str_replace('[','<phoneme alphabet="ipa" ph="',$_name);
		$modNameVal = str_replace(']','"></phoneme>',$modNameVal);
		$post_args = array(	'text' => $modNameVal);
		
		$fileLocation = fopen($obj->settings['uploadDir'] . $filename, 'w+');
		
		$data_string = json_encode($post_args);
		
		$header_args = array('Content-Type: application/json','Accept: audio/wav');
		 
		curl_setopt($curl, CURLOPT_POST, true);
		curl_setopt($curl, CURLOPT_FILE, $fileLocation);
		curl_setopt($curl, CURLOPT_POSTFIELDS, $data_string);
		curl_setopt($curl, CURLOPT_HTTPHEADER, $header_args);
		curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		curl_setopt($curl, CURLOPT_USERPWD, $obj->settings['watson_TTS_user']. ":" . $obj->settings['watson_TTS_password']);
		curl_setopt($curl, CURLOPT_URL, "https://stream.watsonplatform.net/text-to-speech/api/v1/synthesize?voice=" . $obj->settings['watson_TTS_voice']);
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		 
		$result = curl_exec($curl);
		curl_close($curl);
		fwrite($fileLocation, $result);
		fclose($fileLocation);
		
		$decoded = json_decode($result, true);
		
		$i=0;$arr=null;
		$arr[$i]['parameter'] = ':studentID';
		$arr[$i]['value'] = (int)$Student->studentID;
		$arr[$i]['data_type'] = PDO::PARAM_INT;
		$i++;
		$arr[$i]['parameter'] = ':' . $_type . 'Pronunciation';
		$arr[$i]['value'] = $_name;
		$arr[$i]['data_type'] = PDO::PARAM_STR;
		$i++;
		$query = '	UPDATE `'.$obj->settings['tablePrefix'].'Students`
					SET '.$_type.'Pronunciation = :'.$_type.'Pronunciation
					WHERE studentID = :studentID  ';
		$obj->executeSQL($query,$arr);
		
		echo '<audio src="'. $obj->settings['fullBaseUrl'] . '/files'. $filename .'?t='.$t.'" controls autoplay></audio>';
	}
	else{
		echo '<audio src="'. $obj->settings['fullBaseUrl'] . '/files'. $filename .'?t='.$t.'" controls autoplay></audio>';
	}	
?>