<?php
  $query = "SELECT DISTINCT Date_Format(cs.created, \"%m/%d/%Y\") AS createdDate, COUNT(eid) AS numStu, IFNULL(SUM(guest),0) AS numGuest, 
              CASE 
                WHEN attendance = 1 THEN \"Will Attend\"
                WHEN attendance = 2 THEN \"Will NOT Attend\"
                WHEN attendance = 3 THEN \"Different Location\"
                ELSE \"No response\"
              END as attendanceStatus
            FROM `".$obj->settings['tablePrefix']."Students` cs 
            WHERE cs.eid = (SELECT evt.eid FROM `".$obj->settings['tablePrefix']."Events` evt ORDER BY evt.startDateTime DESC LIMIT 1)
            AND cs.active = 1
            GROUP BY createdDate, attendance
            ORDER BY cs.created ASC, attendance ASC";
  
  $attendanceData = $obj->executeSQL($query);

  var_dump(implode(',', array_map(function($a) { return "\"" .$a->createdDate . "\""; }, $attendanceData)));

  if(count($attendanceData) == 0) {
    echo '<h6 style="color:red;font-family:Arial;">No data found - Please wait for the data to populate if this is a newly created event.<h6>';
  }
  else {
    $chartJSCDN = '<script src="https://cdn.jsdelivr.net/npm/chart.js@2.9.3/dist/Chart.min.js"></script>';
    print '
          <table width="100%">
            <tr>
              <td width="50%" height="100"><canvas id="attendanceChart"></canvas></td>
              <td></td>
            </tr>
          </table>';
    $chartData = "<script>
    var ctx = document.getElementById('attendanceChart').getContext('2d');
    var myChart = new Chart(ctx, {
        type: 'bar',
        data: {
            labels: [". implode(',', array_map(function($a) { return "\"" .$a->createdDate . "\""; }, $attendanceData)) ."],
            datasets: [{
                label: '# of Votes',
                data: [12, 19, 3, 5, 2, 3],
                borderWidth: 1
            }]
        },
        options: {
            scales: {
                yAxes: [{
                    ticks: {
                        beginAtZero: true
                    }
                }]
            }
        }
    });
    </script>";
    $obj->appendFooterAddon($chartJSCDN);
    $obj->appendFooterAddon($chartData);
  }
?>
