<?php $objImport = new Import($_dbSettings, $_settings); ?>

<?php if ($_SERVER['REQUEST_METHOD'] == 'POST'): ?>
<?php
  $inputFileName = $_settings['uploadDir'] . '/import/' . date("Y.m.d") . '-' . date("h.i.a") . '-' . basename($_FILES['excel']['name']);
  $backUpFileName = $_settings['uploadDir'] . '/export/' . date("Y.m.d") . '-' . date("h.i.s.a") . '_DB_backup.sql';

  // Export database prior to every import.  I lack trust.
  echo '<br /><p>Database backed up as <b>' . $backUpFileName . '</b> </p><br /><br />' ;
  $objImport->exportDatabase($backUpFileName);

  //
  if (!empty($_POST['resetcompleteddegrees'])) {
    echo '<br /><br /><div  style="color:#E69500;">YOU RESET THE COMPLETED DEGREES.  IF THIS WAS A MISTAKE PLEASE STOP WHAT YOU ARE DOING AND LET THE DEVELOPER KNOW! Ignore if you are running the first file of a set.</div><br /><br />';
    $objImport->resetCompletedDegrees($_REQUEST['id']);
  }
  

  if (move_uploaded_file($_FILES["excel"]["tmp_name"], $inputFileName)) {
    echo "The file " . basename($_FILES["excel"]["name"]) . " has been uploaded and renamed to " . $inputFileName . ". Please save this reporting if a problem occurs.<br /><br />";
  } else {
    echo "Sorry, there was an error uploading your file.<br /><br />";
    exit();
  }
  
  //  Read your Excel workbook
  try {
    $inputFileType = PHPExcel_IOFactory::identify($inputFileName);
    $objReader     = PHPExcel_IOFactory::createReader($inputFileType);
    $objPHPExcel   = $objReader->load($inputFileName);
  }
  catch (Exception $e) {
    die('Error loading file "' . pathinfo($inputFileName, PATHINFO_BASENAME) . '": ' . $e->getMessage());
  }
  
  //  Get work-sheet dimensions
  $headerRowNum  = (int) $_POST['row_starts'];
  $sheet         = $objPHPExcel->getSheet(0);
  $highestRow    = $sheet->getHighestRow();
  $highestColumn = $sheet->getHighestColumn();
  
  $headingsArray = $sheet->rangeToArray('A' . $headerRowNum . ':' . $highestColumn . $headerRowNum, null, true, true, true);
  $headingsArray = $headingsArray[$headerRowNum]; //was an array. so really flattening the array down. I had to use $headerRowNum because it counts the row number.
  
  /*
   * ==========================================================================================================================================
   * !!!!!!!!!!!!!!!!!!!! CUSTOM CODING BASED ON CAMPUS LEVEL OR HOW THEY RETREIVE THEIR DATA. SUBJECT TO CHANGE (SEE IMPORT.CLASS.PHP) !!!!!!!!!!!!!!!!!!!!
   * ==========================================================================================================================================
   * */
  $r              = -1;
  $namedDataArray = array();
  
  //VALIDATION/CHECKS  (DEFAULT)
  $StudentIDHeaderExists = false;
  
  //Loop data into an array
  for ($row = $headerRowNum + 1; $row <= $highestRow; ++$row) {
    $dataRow = $sheet->rangeToArray('A' . $row . ':' . $highestColumn . $row, null, true, true, true);
    ++$r;
    foreach ($headingsArray as $columnKey => $columnHeading) {
      $columnHeading                      = preg_replace('/[^A-Za-z0-9\-]/', '', $columnHeading);
      $columnHeading                      = preg_replace('/\s+/', '', $columnHeading);
      $columnHeading                      = strtoupper($columnHeading);
      $namedDataArray[$r][$columnHeading] = $dataRow[$row][$columnKey];
      
      //VALIDATION/CHECKS 
      if ($columnHeading == 'ID') {
        $StudentIDHeaderExists = true;
      }
    }
  }
  
  $log         = '';
  $arrStudents = null;

  ini_set('max_execution_time', '300');

  if ($StudentIDHeaderExists) {
    $log = '<br />' . $log;
    //START OF THE STUDENT DATA IMPORT. See student-template.xls file
    foreach ($namedDataArray as $item) {
      $x   = 0;
      $arr = null;

      if (empty($item['ID'])) {
        continue;
      }
      
      $arr[$x]['parameter'] = ':studentID';
      $arr[$x]['value']     = $item['ID'];
      $arr[$x]['data_type'] = PDO::PARAM_STR;
      $x++; 
      
      if (trim($item['CHKOUTSTAT']) != 'Applied for Graduation' && trim($item['CHKOUTSTAT']) != 'Withdrawal' && trim($item['CHKOUTSTAT']) != 'Degree Awarded') {
        $log .= '<div style="color:#E69500;">Student ' . $item['ID'] . ' skipped because of his/her CHKOUTSTAT is not the desired data. [OUTPUTS: <b>' . trim($item['CHKOUTSTAT']) . '</b>]</div>';
        continue;
      } // if you don't see a "ADD" or "REMOVE" value, then move on sir.
      
      switch(trim($item['CHKOUTSTAT'])){
        case 'Applied for Graduation':
          $CRUD = 1;
          break;
        case 'Degree Awarded':
          $CRUD = 1;
          break;
        default:
          $CRUD = 0;
          break;
      }
      /* CAMPUS CHECK ============================================================================================== */
      $log .= $objImport->insertCampusIfNull($item['ACADORGDEPT']);
      
      /* ALT CAMPUS CHECK ============================================================================================== */
      //$log .= $objImport->insertCampusIfNull($item['ALTERNATESITE']);
      // DEV NOTES: I DO NOT HAVE THIS INFORMATION...YET
      
      /* DEGREES CHECK ============================================================================================== */
      $log .= $objImport->insertDegreeIfNull($item['ACADPLAN']);
      
      /* MAJORS AND MINORS ============================================================================================== */
      $log .= $objImport->insertMajorIfNull($item['ACADPLAN'], $item['DESCR'], $item['ACADORGDEPT']);
      //same as above but this time we use first value before underscore.  send in 'Descr' as well.
      
      /* PARSE DNID ============================================================================================== */
      //$dnid        = $objImport->getDNIDbyName($item['DISTINCTION']); 
      //May not need...yet?
      
      /* PARSE CID and alt CID ============================================================================================== */
      //$cid         = $objImport->getCIDbyName($item['CAMPUS']);
      //$altcid      = $objImport->getCIDbyName($item['ALTERNATESITE']);
      // DEV NOTES: I DO NOT HAVE THIS INFORMATION...YET
      
      /* PARSE USER ID from Email ======================================================================================== */ 
      $psuID = $objImport->getUserIDfromEmail($item['UNIVERSITYEMAIL']);
      if (empty($psuID)) {
        $log  .= '<div style="color:#E69500;">(<strong>Warning</strong>) PSU ID not found for <strong>'. $item['UNIVERSITYEMAIL'] .'</strong> which came out as ['. $psuID .']</div>';
      }
      
      /* PARSE Graduation Term Season Code  ======================================================================================== */ 
      $GraduationTermCode = empty($item['GRADUATIONTERMCODE']) ? $item['EXPGRADUATIONTERM'] : $item['GRADUATIONTERMCODE'];
      $semester_season = $objImport->getSeasonCodesFromString($GraduationTermCode);
      
      /* PARSE Graduation Term Year  ======================================================================================== */ 
      $semester_year = $objImport->getSeasonYearFromString($GraduationTermCode);
      
      /* GET DDID  ======================================================================================== */ 
      $ddid = $objImport->getDDIDbyName($item['PLANTYPE']);
      $declareWeight = $objImport->getDeclaredWeightByDDID($ddid);
      
      /* GET Names setup  ======================================================================================== */ 
      $middleInitial= empty($item['MIDDLE'][0]) ? '' : ($item['MIDDLE'][0] . '.');
      $suffix= empty($item['SUFFIX'][0]) ? '' : $item['SUFFIX'];
      $fullName = (string) $item['FIRSTNAME'] . ' ' . $middleInitial . ' ' . $item['LAST'] . ' ' . $suffix;
      
      $i                    = 0;
      $arr                  = null;
      $arr[$i]['parameter'] = ':studentID';
      $arr[$i]['value']     = (int) $item['ID'];
      $arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $arr[$i]['parameter'] = ':eid';
      $arr[$i]['value']     = (int) $_REQUEST['id'];
      $arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $arr[$i]['parameter'] = ':email';
      $arr[$i]['value']     = empty($item['UNIVERSITYEMAIL']) ? 'unknown@PSU.EDU' : (string) strtolower($item['UNIVERSITYEMAIL']);
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':accessID';
      $arr[$i]['value']     = empty($psuID) ? null : (string) $psuID;
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':firstName';
      $arr[$i]['value']     = empty($item['FIRSTNAME']) ? null : (string) $item['FIRSTNAME'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':middleInitial';
      $arr[$i]['value']     = empty($item['MIDDLE']) ? null : (string) ($item['MIDDLE'][0] . '.');
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':lastName';
      $arr[$i]['value']     = empty($item['LAST']) ? null : (string) $item['LAST'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':suffix';
      $arr[$i]['value']     = empty($item['SUFFIX']) ? null : (string) $item['SUFFIX'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':formalName';
      $arr[$i]['value']     = $fullName;
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':gpa';
      $arr[$i]['value']     = empty($item['GPA']) ? null : (string) $item['GPA'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':dnid';
      $arr[$i]['value']     = null;
      $arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $arr[$i]['parameter'] = ':address1';
      $arr[$i]['value']     = empty($item['LOCALADDRESS1']) ? (string) $item['PERMADDRESS1'] : (string) $item['LOCALADDRESS1'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':address2';
      $arr[$i]['value']     = empty($item['LOCALADDRESS1']) ? (string) $item['PERMADDRESS2'] : (string) $item['ADDRESS2'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':city';
      $arr[$i]['value']     = empty($item['LOCALADDRESS1']) ? (string) $item['PERMCITY'] : (string) $item['CITY'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':state';
      $arr[$i]['value']     = empty($item['LOCALADDRESS1']) ? (string) $item['PERMSTATE'] : (string) $item['LOCALSTATE'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':zip';
      $arr[$i]['value']     = empty($item['LOCALADDRESS1']) ? (string) $item['PERMPOSTAL'] : (string) $item['LOCALPOSTAL'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':country';
      $arr[$i]['value']     = (string) $item['LOCALCOUNTRY'] ?? (string) $item['PERMCOUNTRY'] ?? null;
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':createdBy_uid';
      $arr[$i]['value']     = (int) $obj->user->uid;
      $arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $arr[$i]['parameter'] = ':semester_season';
      $arr[$i]['value']     = empty($semester_season) ? null : (string) $semester_season;
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':semester_year';
      $arr[$i]['value']     = empty($semester_year) ? null : (string) $semester_year;
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $arr[$i]['parameter'] = ':cid';
      $arr[$i]['value']     = empty($item['ACADORGDEPT']) || ($declareWeight > 1) ? null : $objImport->getCIDbyName($item['ACADORGDEPT']);
      $arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $arr[$i]['parameter'] = ':cid_alt';
      $arr[$i]['value']     = null;
      $arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;	
      $arr[$i]['parameter'] = ':preferredEmail';
      $arr[$i]['value']     = empty($item['PREFERREDEMAIL']) ? null : (string) $item['PREFERREDEMAIL'];
      $arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      
      
      $CRU = $obj->executeSQL(' INSERT INTO `' . $obj->settings['tablePrefix'] . 'Students` 
                                      (studentID, eid, email, accessID, firstName, middleInitial, lastName, suffix, formalName, gpa, dnid, address1, address2, city, state, zip, country, active, lastUpdated, createdBy_uid, semester_season, semester_year, cid, cid_alt, preferredEmail)
                                  VALUES
                                      (:studentID, :eid, :email, :accessID, :firstName, :middleInitial, :lastName, :suffix, :formalName, :gpa, :dnid, :address1, :address2, :city, :state, :zip, :country, 1, now(), :createdBy_uid, :semester_season, :semester_year, :cid, :cid_alt, :preferredEmail)
                                  ON DUPLICATE KEY 
                                  UPDATE
                                  eid	            =COALESCE(VALUES(eid),eid),
                                  email           =IF(VALUES(email) <> \'unknown@PSU.EDU\',VALUES(email),email),
                                  accessID		    =COALESCE(VALUES(accessID),accessID),
                                  firstName		    =COALESCE(VALUES(firstName),firstName),
                                  middleInitial	  =COALESCE(VALUES(middleInitial),middleInitial),
                                  lastName		    =COALESCE(VALUES(lastName),lastName),
                                  suffix		      =COALESCE(VALUES(suffix),suffix),
                                  formalName      =COALESCE(VALUES(formalName),formalName),
                                  gpa             =COALESCE(VALUES(gpa),gpa),
                                  dnid            =COALESCE(VALUES(dnid),dnid), 
                                  address1        =COALESCE(VALUES(address1),address1), 
                                  address2        =COALESCE(VALUES(address2),address2), 
                                  city            =COALESCE(VALUES(city),city),
                                  state			      =COALESCE(VALUES(state),state), 
                                  zip             =COALESCE(VALUES(zip),zip), 
                                  country         =COALESCE(VALUES(country),country, NULL), 
                                  active		      =COALESCE(VALUES(active),active), 
                                  lastUpdated	    =COALESCE(VALUES(lastUpdated),lastUpdated), 
                                  semester_season =COALESCE(VALUES(semester_season),semester_season), 
                                  semester_year   =COALESCE(VALUES(semester_year),semester_year), 
                                  cid             =COALESCE(VALUES(cid),cid), 
                                  cid_alt         =COALESCE(VALUES(cid_alt),cid_alt),
                                  preferredEmail  =COALESCE(VALUES(preferredEmail), preferredEmail)	', $arr, $limit = 'all', $page = 1, $debugMode = true);
      $log .= '<div>(<strong>ADD/UPDATE</strong>) StudentID <strong>' . $item['ID'] . '</strong> marked active. Info updated.</div>';
      
      $careernbr = (int)$item['CAREERNBR'] + 1;
      
      $log .= $objImport->attachCompletedDegrees($item['ID'], $item['ACADPLAN'], $item['PLANTYPE'], null, $careernbr, $CRUD, (int) $_REQUEST['id']);
    }
  } else {
    print '<h2 style="color:red">POTENTIAL Headers Missing / Incorrect Header Row location. <br / > Please see our Excel template for details. Following Header(s) <u>POTENTIALLY</u> required:</h2>';
    if (!$StudentIDHeaderExists) {
      print '<h3 style="color:red">Student ID missing</h3>';
    }
  }
  
  //resolve completed degrees primary weight fixing..
  $objImport->cleanUpStudentsData();
  
  print $log;
  print '<h2>Upload complete.</h2>';
   
  //echo '<pre>';
    
  //print_r($namedDataArray);
    
  //echo '</pre>';
    /*
   * ==========================================================================================================================================
   * !!!!!!!!!!!!!!!!!!!! END OF CUSTOM CODING  !!!!!!!!!!!!!!!!!!!!
   * ==========================================================================================================================================
   * */
?>
<?php else: ?>
        <form action="" method="post" enctype="multipart/form-data" class="frm">
          <div class="formfield">
            <label class="formlabel"><span class="red">*</span>Header Row:</label>
            <input type="text" name="row_starts" value="1" required />
            <div class="tooltip help fL">
              <span>?</span>
              <div class="content">
                <b></b>
                <p>The row number where the header is located. Please note, data must start AFTER the header row. Please adjust data if malformed. By default: Row number 5.</p>
                <div class="clr"></div>
              </div>
            </div>
            <div class="clr"></div>
          </div>
          
          <div class="formfield">
            <label class="formlabel"><span class="red"></span>Reset Student Degrees <br><span style="font-size: .7em">(Hover over "?" for more info):</span></label>
            <input type="checkbox" name="resetcompleteddegrees" value="1" />
            <div class="tooltip help fL">
              <span>?</span>
              <div class="content">
                <font color="orange">
                  <b>If you have an "EVERYTHING FILE", a single file that contains all the students.  Please check this box. If you are supplimenting an "EVERYTHING FILE", then do NOT check this.</b><br><br>
                  IMPORTANT: This is *ONLY* turned on when you do the first of many files.  Because this will reset the data of completed degrees. If you run this again with the graduate file AFTER uploading the UNDERGRAD file, it WILL remove UNDERGRAD data. Database will be backed up but I recommend stopping if you made a mistake after turning this on.</font></p>
                <div class="clr"></div>
              </div>
            </div>
            <div class="clr"></div>
          </div>
          
          <div class="formfield">
            <label class="formlabel"><span class="red">*</span>File:</label>
            <input type="file" name="excel" value="5" class=" " />
            <div class="tooltip help fL">
              <span>?</span>
              <div class="content">
                <b></b>
                <p>Recommended file: XLS.
                  <br>
                  <br>However it will accept spreadsheet file formats, like Excel (BIFF) .xls, Excel 2007 (OfficeOpenXML) .xlsx, CSV, Libre/OpenOffice Calc .ods, Gnumeric, PDF, HTML.
                  <br/>
                  <br/><font color="orange">IMPORTANT: This import will only use the first sheet from the spreadsheet file.</font></p>
                <div class="clr"></div>
              </div>
            </div>
            <div class="clr"></div>
          </div>
          <div class="formfield">
            <label class="formlabel">&nbsp;</label>
            <input type="submit" name="submit" value="Start Importing File" class="button" />
            <div class="clr"></div>
          </div>
        </form>
<?php endif; ?>