var notEnoughSeats 			= 'Not enough seats. Please go to VENUE SEATING and add more or edit the buffer and starting seats here.';
var seatsReasonsDisabled 	= 'One of the following has occurred: <ul><li>Selected "Starting Seat" is overlapped by a previous "OVERRIDE" / "BUFFER"</li><li>Selected "Starting Seat" was surpassed because additional students registered (RSVP) for the event.</li></ul>  To resolve, please change starting seat or have it automatically choose for you. <br /> ';
var refreshSeats 			= '<p>Seeing this in error? &nbsp;<a onclick="updateSeatsInputs()" style="cursor:pointer;">[Click here to revalidate]</a></p>&nbsp;';

notEnoughSeats = notEnoughSeats.concat(refreshSeats);
seatsReasonsDisabled = seatsReasonsDisabled.concat(refreshSeats);

function IsEmail(email) {
  var regex = /^([a-zA-Z0-9_.+-])+\@(([a-zA-Z0-9-])+\.)+([a-zA-Z0-9]{2,4})+$/;
  return regex.test(email);
}

function escapeRegExp(str) {
  return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|\@]/g, "\\$&");
}

function responsiveOnly()
{
	
}

function updateSeatsInputs(){
	var numberOfSeats = 0;
	var numberOfOptions = 0;
	var cnt = 0;
	
	$(".errorMsg").hide();
	
	$("#marchingListForm table.seatingInputs").each(function(){
		cnt++;
		var dom = $(this);
		var timer = setInterval(function(){
			var currentID = dom.attr('currentID');
			if (isNaN(Number($("#seatSelector_" + currentID + " select").attr('total'))) === false) {
				var currentID = dom.attr('currentID');
				var previousID = dom.attr('previousID');
				var nextID = dom.attr('nextID');
				
				if(	Number(numberOfOptions) == Number(0) ){
					var _currentOption 	= Number($("#seatSelector_" + currentID + " select").attr('total'));
					var _prevOption 	= Number($("#seatSelector_" + previousID + " select").attr('total'));
					var _nextOption 	= Number($("#seatSelector_" + nextID + " select").attr('total'));
					if( !isNaN(_currentOption) ){
						numberOfOptions = _currentOption;
					}
					else if( !isNaN(_prevOption) ){
						numberOfOptions = _prevOption;
					}
					else if( !isNaN(_nextOption) ){
						numberOfOptions = _nextOption;
					}
				}
				
				numberOfSeats = updateSeat(currentID,previousID,false,numberOfSeats,numberOfOptions);
				clearInterval(timer);
				if(cnt === $("#marchingListForm table.seatingInputs").length){
					refreshSeatingSelect();
				}
			}
			else{
				console.log('dom does not exist yet...reloading...');
			}
		}, 10);
	});
}

function updateSeat(currentID,previousID,nextID,numberOfSeats,numberOfOptions){
	if( $("#override_" + currentID).val() == "override"){
		$("#seatSelector_" + currentID + " select").prop("disabled", false);
		if(previousID){ $("#buffer_" + previousID).prop("disabled", true); }
	}
	else{
		$("#seatSelector_" + currentID + " select").prop("disabled", true);
		$("#seatSelector_" + currentID + " select option[value!='']:first").prop("selected",true);
		if(previousID){ $("#buffer_" + previousID).prop("disabled", false); }
	}
	if(previousID){	
		var seatsTaken = isNaN(Number($("#seatsTaken_"+previousID).val())) ? 0 : Number($("#seatsTaken_"+previousID).val());
		var buffer = isNaN(Number($("#buffer_"+previousID).val())) ? 0 : Number($("#buffer_"+previousID).val());
		numberOfSeats = numberOfSeats+seatsTaken+buffer;
		if($("#override_"+previousID).val() == 'override'){
			numberOfSeats = numberOfSeats + $("#seatSelector_" + previousID + " select option:selected").prevAll(":enabled").length;
		}
		var x = 1;
		$('#seatSelector_' + currentID + ' select option[value!=""]').each(function(){
			if(x <= numberOfSeats){
				$(this).prop('disabled', true);
			}
			else{
				$(this).prop('disabled', false);
			}
			x++;
		});
		if( Number(numberOfSeats) >= numberOfOptions ){
			$("#errorMsg_"+previousID).html(notEnoughSeats);
			$("#errorMsg_"+previousID).show();
			$('#marchingListForm input[type="submit"]').prop('disabled', true).hide();
			$('#marchingListForm .submitError').show();
		}
		else{
			$("#errorMsg_"+previousID).html('');
			$("#errorMsg_"+previousID).hide();
			$('#marchingListForm input[type="submit"]').prop('disabled', false).show();
			$('#marchingListForm .submitError').hide();
		}
	}
	
	return numberOfSeats;
}

function refreshSeatingSelect(){
	$("#marchingListForm table.seatingInputs").each(function(){
		var currentID = $(this).attr('currentID');
		if( $("#override_" + currentID).val() != "override"){
			$(this).find('.seatSelect select option:enabled:first').prop('selected',true);
		}
		if( $("#seatSelector_" + currentID + " select option:selected").prop('disabled') === true){
			if($("#seatSelector_" + currentID + " select option:enabled").length > 0){
				$("#errorMsg_"+currentID).html(seatsReasonsDisabled);
			}
			else{
				$("#errorMsg_"+currentID).html(notEnoughSeats);
			}
			$("#errorMsg_"+currentID).show();
			$('#marchingListForm input[type="submit"]').prop('disabled', true).hide();
			$('#marchingListForm .submitError').show();
		}
	});
}

function selectEnabledSeat(currentID){
	$("#seatSelector_" + currentID + " select option:enabled:first").prop('selected',true);
}

$(document).ready(function(){
	//slick nav
	$('#menu').slicknav();
	
	//creates a new attribute for tables TD based off of the TH it belongs with (occurs within "#main .content")
	$("#main td").each(function(){$(this).closest("tbody").prev("thead").find("> tr > th:eq("+$(this).index()+")").text().replace(/((<([^>]+)>)|&#{0,1}[a-z0-9]+;)/gi,"").trim().length>0?$(this).attr("data-title",$(this).closest("tbody").prev("thead").find("> tr > th:eq("+$(this).index()+")").text().replace(/((<([^>]+)>)|&#{0,1}[a-z0-9]+;)/gi,"").trim()+": "):$(this).attr("data-title","")});
	
	//tooltip
	$('.tooltip img').on('touchend', function(e) {
    	$(this).next('.tip').hide();
	});
	$('.tooltip img').on('touchstart', function(e) {
    	$(this).next('.tip').show();
	});
	
	//DateTimePicker
	Date.parseDate = function( input, format ){
	  return moment(input,format).toDate();
	};
	Date.prototype.dateFormat = function( format ){
	  return moment(this).format(format);
	};
	$('.datetimepicker').datetimepicker({
		format:'MM/DD/YYYY hh:mm a',
		formatTime:'hh:mm a',
		formatDate:'MM/DD/YYYY'
	});
	
	//seating tables with TR and a checkbox 
	$('.seating tr').click(function(event) {
	    if (event.target.type !== 'checkbox') {
	      $(':checkbox', this).trigger('click');
	    }
	});
	$('.seating :not(:has(*))').html(function(i, v) {
		if( $("input[name*='searchtext']").length ){
			var regex = new RegExp( escapeRegExp($("input[name*='searchtext']").val()) ,"g");
			return v.replace(regex, '<span class=\"searchTextHighlight\">'+$("input[name*='searchtext']").val()+'<\/span>');    
		}
	});
	
	//marching list form prior to submit
	$("#marchingListForm").submit(function(){
		$("#marchingListForm select:disabled").prop('disabled',false);
	});
	
	//infoMsg tip item
	$('.infoMsg').each(function(){
		var item = $(this);
		$(this).find('div.item').each(function(i){
			$(this).prepend('<strong>Tip #' + (i+1) + ':</strong> ');
		});
		$(this).find('div.item:first').addClass('active');
		$(this).append('<div class="arrows clrWithin"><div class="fL"><a href="#" class="previous button">&lArr; Previous</a></div><div class="fR"><a href="#" class="next button">Next &rArr;</a></div></div>');
		if($(this).find('div.item').length > 1){
			$(this).find('.arrows').show();
		}
		$(this).find('.next').click(function(){
			if( item.find('div.item.active').is(".item:last") ){
				item.find('div.item.active').removeClass('active').hide();
				item.find('div.item:first').addClass('active').show();
			}
			else{
				item.find('div.item.active').removeClass('active').hide().next('div.item').addClass('active').show();
			}
		});
		$(this).find('.previous').click(function(){
			if( item.find('div.item.active').is(".item:first") ){
				item.find('div.item.active').removeClass('active').hide();
				item.find('div.item:last').addClass('active').show();
			}
			else{
				item.find('div.item.active').removeClass('active').hide().prev('div.item').addClass('active').show();
			}
		});
	});

	//responsive only
	responsiveOnly();
	$(window).resize(function(){
		responsiveOnly();
	});
});

