<?php
/*
 * ==========================================================================================================================================
 * !!!!!!!!!!!!!!!!!!!! CUSTOM CODING BASED ON CAMPUS LEVEL OR HOW THEY RETREIVE THEIR DATA. SUBJECT TO CHANGE !!!!!!!!!!!!!!!!!!!!
 * ==========================================================================================================================================
 * */
class Import extends Core
{
  /* Insert Campus if Null 
   * returns string(log)
   * ============================================================================================== */
  function insertCampusIfNull($code)
  {
    if (empty($code)) {
      return '';
    }
    
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':code';
    $i_arr[$i]['value']     = $code;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $checkIfCampusExists = $this->executeSQL(' SELECT cid FROM `' . $this->settings['tablePrefix'] . 'Campuses` WHERE `code` = :code ', $i_arr);
    
    if (count($checkIfCampusExists) == 0) {
      $i_arr[$i]['parameter'] = ':name';
      $i_arr[$i]['value']     = 'UNKNOWN UNIT -> Code: ' . $code;
      $i_arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $i_arr[$i]['parameter'] = ':active';
      $i_arr[$i]['value']     = 1;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $i_arr[$i]['parameter'] = ':createdBy_uid';
      $i_arr[$i]['value']     = $this->user->uid;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $insert  = $this->executeSQL(' 
											INSERT INTO `' . $this->settings['tablePrefix'] . 'Campuses` 
											(`name`,`code`,`weight`,`active`,`createdBy_uid`)
											SELECT :name,:code,IF(SUM(c.weight) is null, 100,MAX(c.weight)+100),:active,:createdBy_uid FROM `' . $this->settings['tablePrefix'] . 'Campuses` c ORDER BY c.weight DESC LIMIT 1
											', $i_arr);
      $editURL = $this->settings['baseFolder'] . 'campuses?act=edit&id=' . $insert;
      return '<div style="color:#E69500;">(<strong>Warning</strong>) Unit <strong>' . $code . '</strong> does not exist.  Inserting new unit. Please edit campus name by clicking <a href="' . $editURL . '" target="_blank">this link</a> (opens in a new window). <span style="font-size:80%">*may require reimporting if campus already exists on your list</span></div> ';
    }
    return '';
  }
  
  /* Insert Degree if Null 
   * @returns string(log) 
   * ============================================================================================== */
  function insertDegreeIfNull($code)
  {
    if (empty($code)) {
      return '<div style="color:#E69500;">(<strong>Warning</strong>) Academic Plan was blank. </strong></div>';
    }
    
    $degreeArr = $this->getDegreeInfoByString($code);
    
    if (count($degreeArr) != 2){
      return '<div style="color:#E69500;">(<strong>Error</strong>) Academic Plan '.$code.' does not have an underscore. </strong></div>';
    }
    
    $degreeType = trim($degreeArr[1]);
    
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':code';
    $i_arr[$i]['value']     = $degreeType;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $checkIfDegreeExists = $this->executeSQL(' SELECT did FROM `' . $this->settings['tablePrefix'] . 'Degrees` WHERE `code` = :code ', $i_arr);
    $getDTID             = $this->executeSQL(' SELECT IFNULL(min(dtid),0) as dtid FROM `' . $this->settings['tablePrefix'] . 'DegreeTypes` ');
    
    if (count($checkIfDegreeExists) == 0) {
      $i_arr[$i]['parameter'] = ':name';
      $i_arr[$i]['value']     = 'UNKNOWN DEGREE -> Code: ' . $code;
      $i_arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $i_arr[$i]['parameter'] = ':abbrName';
      $i_arr[$i]['value']     = 'UNKNOWN ABBREVIATION -> Code: ' . $code;
      $i_arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $i_arr[$i]['parameter'] = ':dtid';
      $i_arr[$i]['value']     = $getDTID[0]->dtid;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $i_arr[$i]['parameter'] = ':active';
      $i_arr[$i]['value']     = 1;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $i_arr[$i]['parameter'] = ':createdBy_uid';
      $i_arr[$i]['value']     = $this->user->uid;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $insert  = $this->executeSQL(' 
											INSERT INTO `' . $this->settings['tablePrefix'] . 'Degrees` 
											(`name`,`abbrName`,`code`,`weight`,`dtid`,`active`,`createdBy_uid`)
											SELECT :name,:abbrName,:code,IF(SUM(c.weight) is null, 100,MAX(c.weight)+100),:dtid,:active,:createdBy_uid FROM `' . $this->settings['tablePrefix'] . 'Degrees` c ORDER BY c.weight DESC LIMIT 1
											', $i_arr);
      $editURL = $this->settings['baseFolder'] . 'degrees?act=edit&id=' . $insert;
      return '<div style="color:#E69500;">(<strong>Warning</strong>) Degree <strong>'. $degreeType .' from the code ' . $code . '</strong> does not exist.  Inserting new Degree. Please edit degree by clicking <a href="' . $editURL . '" target="_blank">this link</a> (opens in a new window).</div>';
    }
    return '';
  }
  
  /* Insert Major/Minor if Null 
   * @returns string(log)
   * ============================================================================================== */
  function insertMajorIfNull($code, $descr, $cid)
  {
    if (empty($code)) {
      return '<div style="color:#E69500;">(<strong>Warning</strong>) Acad Plan was blank. </strong></div>';
    }
    if (empty($descr)) {
      return '<div style="color:#E69500;">(<strong>Warning</strong>) Descr was blank. </strong></div>';
    }
    
    $degreeArr = $this->getDegreeInfoByString($code);
    
    if (count($degreeArr) != 2){
      return '<div style="color:#E69500;">(<strong>Error</strong>) Academic Plan '.$code.' does not have an underscore. </strong></div>';
    }
    
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':code';
    $i_arr[$i]['value']     = $degreeArr[0];
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $checkIfMajorExists = $this->executeSQL(' SELECT mid FROM `' . $this->settings['tablePrefix'] . 'Majors` WHERE `code` = :code ', $i_arr);
    
    if (count($checkIfMajorExists) == 0) {
      $i_arr[$i]['parameter'] = ':name';
      $i_arr[$i]['value']     = $descr;
      $i_arr[$i]['data_type'] = PDO::PARAM_STR;
      $i++;
      $i_arr[$i]['parameter'] = ':cid';
      $i_arr[$i]['value']     = empty($cid) ? 0 : $this->getCIDbyName($cid);;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $i_arr[$i]['parameter'] = ':active';
      $i_arr[$i]['value']     = 1;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $i_arr[$i]['parameter'] = ':createdBy_uid';
      $i_arr[$i]['value']     = $this->user->uid;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $insert  = $this->executeSQL(' 
											INSERT INTO `' . $this->settings['tablePrefix'] . 'Majors` 
											(`name`,`code`,`weight`,`cid`,`active`,`createdBy_uid`)
											SELECT :name,:code,IF(SUM(c.weight) is null, 100,MAX(c.weight)+100),:cid,:active,:createdBy_uid FROM `' . $this->settings['tablePrefix'] . 'Majors` c ORDER BY c.weight DESC LIMIT 1
											', $i_arr);
      $editURL = $this->settings['baseFolder'] . 'majors?act=edit&id=' . $insert;
      return '<div style="color:#E69500;">(<strong>Warning</strong>) Major <strong>'. $degreeArr[1] .' from the code ' . $code . '</strong> does not exist.  Inserting new Major as <strong>'.$descr.'</strong>. Please correct spelling and formatting by editing the degree by clicking <a href="' . $editURL . '" target="_blank">this link</a> (opens in a new window).</div>';
      
    }
    return '';
  }

  /* get proper degree info by string
   * @returns array 
   * ============================================================================================== */
  function getDegreeInfoByString($code)
  {
    if (strlen($code) >= 10 && strpos($code,'_') === false){
      $degreeArr[0] = substr($code, 0, 5);
      $degreeArr[1] = substr($code, 5);
      return $degreeArr;
    } elseif(strpos($code,'_') > 0) {
      $code = preg_replace('/((?<=\_)[^_]*)\_/', '$1',$code); //for degrees that are like TC_M_ED or TRDEV_M_ED to be converted into TC_MED and TRDEV_MED
      return explode('_', $code);
    } 
    return false;
  }
  
  
  /* get DNID by name
   * @returns int 
   * ============================================================================================== */
  function getDNIDbyName($text)
  {
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':distinction';
    $i_arr[$i]['value']     = $text;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $getID = $this->executeSQL(' SELECT dnid FROM `' . $this->settings['tablePrefix'] . 'Distinctions` WHERE  distinction = :distinction ', $i_arr);
    if (count($getID) > 0) {
      return $getID[0]->dnid;
    }
    return 0;
  }
  
  /* get CID by code 
   * @returns int
   * ============================================================================================== */
  function getCIDbyName($text)
  {
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':code';
    $i_arr[$i]['value']     = $text;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $getID = $this->executeSQL(' SELECT cid FROM `' . $this->settings['tablePrefix'] . 'Campuses` WHERE  code = :code ', $i_arr);
    if (count($getID) > 0) {
      return $getID[0]->cid;
    }
    return 0;
  }
  /* get mid by code
   * @returns int 
   * ============================================================================================== */
  function attachCompletedDegrees($studentID = null, $degreeCode = null, $declared = null, $schoolname = null, $weight = null, $willreceive, $eid = null)
  {
    $log = '';
    if (($studentID == null) || (empty($weight)) ) {
      return '<div style="color:#cdcdcd;font-size:85%;font-style:italic;padding-left:1em;">attachCompletedDegrees > error code: 0</div>';
    }
    
    if (empty($degreeCode)) {
      return '<div style="color:#cdcdcd;font-size:85%;font-style:italic;padding-left:1em;">attachCompletedDegrees > error code: 1</div>';
    }
    
    $ddid  = $this->getDDIDbyName($declared);
    
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':studentID';
    $i_arr[$i]['value']     = $studentID;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':ddid';
    $i_arr[$i]['value']     = $ddid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':eid';
    $i_arr[$i]['value']     = $eid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $getMaxWeight = $this->executeSQL(' SELECT (COALESCE(MAX(weight),0)+1) as maxweight,count(weight) as numweight FROM `' . $this->settings['tablePrefix'] . 'CompletedDegrees` WHERE studentID = :studentID AND ddid = :ddid AND willReceive = 1 AND eid = :eid ', $i_arr);
    
    $weight = (int)$getMaxWeight[0]->maxweight;
    
    $degreeArr = $this->getDegreeInfoByString($degreeCode);
    
    if (count($degreeArr) != 2){
      return '<div style="color:#cdcdcd;font-size:85%;font-style:italic;padding-left:1em;">attachCompletedDegrees > error code: 2</div>';
    }
    
    //This is to see if someone imports a grad degree into a student with an undergrad degree marked as primary...
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':studentID';
    $i_arr[$i]['value']     = $studentID;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':did';
    $i_arr[$i]['value']     = $this->getDIDbyCode($degreeArr[1]);;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':eid';
    $i_arr[$i]['value']     = $eid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $checkIfSqueezingGradToUndergradPrimary = $this->executeSQL('
     SELECT cd.*
     FROM `' . $this->settings['tablePrefix'] . 'CompletedDegrees` cd 
     JOIN `' . $this->settings['tablePrefix'] . 'Degrees` d_original ON cd.did = d_original.did
     JOIN `' . $this->settings['tablePrefix'] . 'DegreeTypes` dt_original ON dt_original.dtid = d_original.dtid
     ,`' . $this->settings['tablePrefix'] . 'Degrees` d_new
     JOIN `' . $this->settings['tablePrefix'] . 'DegreeTypes` dt_new ON dt_new.dtid = d_new.dtid
     WHERE cd.weight = 1 
     AND d_new.did = :did 
     AND cd.eid = :eid
     AND cd.studentID = :studentID
     ORDER BY dt_original.weight DESC', $i_arr,true);
    if (count($checkIfSqueezingGradToUndergradPrimary) > 0) {
      $editURL = $this->settings['baseFolder'] . 'events?act=students&id='.$eid.'&by=edit&studentID=' . $studentID;
      $log .= '<div style="color:#E69500;">(<strong>Warning</strong>) Student <strong> '.$studentID.' </strong> primary degree needs to be rearranged by clicking <a href="' . $editURL . '" target="_blank">this link</a> (opens in a new window).</div>';
    }
    
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':studentID';
    $i_arr[$i]['value']     = $studentID;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':mid';
    $i_arr[$i]['value']     = $this->getMIDByCode($degreeArr[0]);
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':did';
    $i_arr[$i]['value']     = $this->getDIDbyCode($degreeArr[1]);
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':ddid';
    $i_arr[$i]['value']     = $ddid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':eid';
    $i_arr[$i]['value']     = $eid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $getExistingCD = $this->executeSQL(' SELECT cdid FROM `' . $this->settings['tablePrefix'] . 'CompletedDegrees` WHERE studentID = :studentID AND mid = :mid AND did = :did AND ddid = :ddid AND eid = :eid ', $i_arr);
    
    if ($weight > 1 && $ddid == 1) {
      $ddid = 3; //3 means concurrent. hack job. because if it's not the first "MAJOR" then it must be concurrent 
      if (count($getExistingCD) === 0) {
        $getExistingCD = $this->executeSQL(' SELECT cdid FROM `' . $this->settings['tablePrefix'] . 'CompletedDegrees` WHERE studentID = :studentID AND mid = :mid AND did = :did AND ddid = 3 AND eid = :eid AND :ddid = :ddid ', $i_arr); //Another hack job.
      }
    }

    if (count($getExistingCD) > 0) {
      $i                      = 0;
      $i_arr                  = null;
      $i_arr[$i]['parameter'] = ':cdid';
      $i_arr[$i]['value']     = $getExistingCD[0]->cdid;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $i_arr[$i]['parameter'] = ':willReceive';
      $i_arr[$i]['value']     = $willreceive;
      $i_arr[$i]['data_type'] = PDO::PARAM_INT;
      $i++;
      $getID = $this->executeSQL(' UPDATE `' . $this->settings['tablePrefix'] . 'CompletedDegrees` SET willReceive = :willReceive WHERE cdid = :cdid ', $i_arr);
      
      return $log . '<div style="color:#cdcdcd;font-size:85%;font-style:italic;padding-left:1em;">Successfully updated degree that already exists: ('.$degreeArr[0].' to student ' .$studentID. ')</div>';
    }
    
    
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':studentID';
    $i_arr[$i]['value']     = $studentID;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':schoolName';
    $i_arr[$i]['value']     = $schoolname;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $i_arr[$i]['parameter'] = ':mid';
    $i_arr[$i]['value']     = $this->getMIDByCode($degreeArr[0]);
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':did';
    $i_arr[$i]['value']     = $this->getDIDbyCode($degreeArr[1]);
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':ddid';
    $i_arr[$i]['value']     = $ddid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':eid';
    $i_arr[$i]['value']     = $eid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':weight';
    $i_arr[$i]['value']     = $this->getDeclaredWeightByDDID($ddid);
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':willReceive';
    $i_arr[$i]['value']     = $willreceive;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $getID = $this->executeSQL(' INSERT INTO `' . $this->settings['tablePrefix'] . 'CompletedDegrees`(studentID,mid,did,ddid,eid,schoolName,weight,willReceive) 
										VALUES(:studentID,:mid,:did,:ddid,:eid,:schoolName,:weight,:willReceive) ', $i_arr);
    return $log . '<div style="color:#cdcdcd;font-size:85%;font-style:italic;padding-left:1em;">Successfully attached degree '.$degreeArr[0].' to student ' .$studentID. '</div>';
  }
  /* get mid by code
   * @returns int 
   * ============================================================================================== */
  function attachPastGradInfo($studentID = null, $degreeCode = null, $schoolname = null)
  {
    if (($studentID == null) || ($degreeCode == null) || empty($schoolname)) {
      return 0;
    }
    
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':studentID';
    $i_arr[$i]['value']     = $studentID;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $i_arr[$i]['parameter'] = ':schoolName';
    $i_arr[$i]['value']     = $schoolname;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $i_arr[$i]['parameter'] = ':did';
    $i_arr[$i]['value']     = $this->getDIDbyCode($degreeCode);
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $getID = $this->executeSQL(' INSERT INTO `' . $this->settings['tablePrefix'] . 'CompletedDegrees`(studentID,did,schoolName,willReceive) 
										VALUES(:studentID,:did,:schoolName,0) ', $i_arr);
    
    return 1;
  }
  /* get mid by code
   * @returns int 
   * ============================================================================================== */
  function getMIDByCode($code)
  {
    $code                   = preg_replace('/[^A-Za-z0-9\-]/', '', $code);
    $code                   = preg_replace('/\s+/', '', $code);
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':code';
    $i_arr[$i]['value']     = $code;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $getID = $this->executeSQL(' SELECT mid FROM `' . $this->settings['tablePrefix'] . 'Majors` WHERE  code = :code ', $i_arr);
    if (count($getID) > 0) {
      return $getID[0]->mid;
    }
    return null;
  }
  /* get ddid by name
   * @returns int 
   * ============================================================================================== */
  function getDDIDbyName($code)
  {
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':declared';
    $i_arr[$i]['value']     = $code;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $getID = $this->executeSQL(' SELECT ddid FROM `' . $this->settings['tablePrefix'] . 'Declared` WHERE  declared = :declared ', $i_arr);
    if (count($getID) > 0) {
      return $getID[0]->ddid;
    }
    return null;
  }
  /* get declared (table) weight by ddid
   * @returns int 
   * ============================================================================================== */
  function getDeclaredWeightByDDID($ddid)
  {
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':ddid';
    $i_arr[$i]['value']     = $ddid;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $getweight= $this->executeSQL(' SELECT weight FROM `' . $this->settings['tablePrefix'] . 'Declared` WHERE  ddid = :ddid ', $i_arr);
    if (count($getweight) > 0) {
      return $getweight[0]->weight;
    }
    return null;
  }
  /* get userid from email
   * @returns str 
   * ============================================================================================== */
  function getUserIDfromEmail($code)
  {
    if (!empty($code)){ 
      $getuserid    = preg_replace('/(\@.*?)$/', '', $code);
      $getuserid    = trim($getuserid);
      if (!empty($getuserid)){
        return strtolower($getuserid);
      }
    }
    return null;
  }
  /* get semester graduationg season code from string
   * @returns str 
   * ============================================================================================== */
  function getSeasonCodesFromString($code)
  {
    if (!empty($code) && strlen($code) === 4){ 
      switch( (int) $code[3]){
        case 1:
          $season = 'SP';
          break;
        case 8:
          $season = 'FA';
          break;
        default:
          $season = 'SU';
          break;
      }
      return $season;
    }
    return null;
  }
  /* get semester graduationg year from string
   * @returns str 
   * ============================================================================================== */
  function getSeasonYearFromString($code)
  {
    if (!empty($code) && strlen($code) === 4){ 
      $year = (int) ($code[1] . $code[2]);
      return $year;
    }
    return null;
  }
  /* get did by code
   * @returns int 
   * ============================================================================================== */
  function getDIDbyCode($code)
  {
    $code                   = preg_replace('/[^A-Za-z0-9\-]/', '', $code);
    $code                   = preg_replace('/\s+/', '', $code);
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':code';
    $i_arr[$i]['value']     = $code;
    $i_arr[$i]['data_type'] = PDO::PARAM_STR;
    $i++;
    $getID = $this->executeSQL(' SELECT did FROM `' . $this->settings['tablePrefix'] . 'Degrees` WHERE  code = :code ', $i_arr);
    if (count($getID) > 0) {
      return $getID[0]->did;
    }
    return null;
  }
  /* resolve the ddid and weight of completed degrees.  This will rearrange weight for majors for grad first over undergrad and remove dupes
   * @returns int 
   * ============================================================================================== */
  function cleanUpStudentsData()
  {
    //remove dupes
    $this->executeSQL('
      DROP TABLE IF EXISTS `uniqueCompletedDegrees`;
      CREATE TABLE `uniqueCompletedDegrees` LIKE `' . $this->settings['tablePrefix'] . 'CompletedDegrees`;
      INSERT INTO `uniqueCompletedDegrees`
      SELECT * FROM `' . $this->settings['tablePrefix'] . 'CompletedDegrees` GROUP BY studentID,mid,did,ddid,eid,weight,willReceive ORDER BY weight;
      DROP TABLE `' . $this->settings['tablePrefix'] . 'CompletedDegrees`;
      RENAME TABLE `uniqueCompletedDegrees` TO `' . $this->settings['tablePrefix'] . 'CompletedDegrees`;
    ');
    
    return null;
  }
  /* Backs up data
   * @returns bool
   * ============================================================================================== */
  function exportDatabase($targetFilePath)
  {
    $host     = $this->_dbHost;
    $user     = $this->_dbUsername;
    $password = $this->_dbPassword;
    $database = $this->_dbName;
    
    return exec('mysqldump --host=\''. $host .'\' --user=\''. $user .'\' --password=\''. $password .'\' '. $database .' --add-drop-table --single-transaction > '. $targetFilePath) === 0;
  }
  /* Removes completed Degrees
   * @returns bool 
   * ============================================================================================== */
  function resetCompletedDegrees($eid)
  {
    $i                      = 0;
    $i_arr                  = null;
    $i_arr[$i]['parameter'] = ':eid';
    $i_arr[$i]['value']     = $eid;
    $i_arr[$i]['data_type'] = PDO::PARAM_INT;
    $i++;
    $this->executeSQL('DELETE FROM `' . $this->settings['tablePrefix'] . 'CompletedDegrees` WHERE eid = :eid', $i_arr);
    return true;
  }
  
}