<?php

	class Pagination
	{
		private $_limit;
		private $_page;
		private $_total;
	
		public function __construct( $total, $limit, $page )
		{
			$this->_total 	= $total;
			$this->_limit 	= $limit;
			$this->_page 	= $page;
		}
		
		public function createLinks( $baseURL, $numOflinks, $list_class ) {
			$URL  = $baseURL	.	(strpos($baseURL, '?') !== false ? '&' : '?');
			if ( $this->_limit == 'all' ) {
				return '';
			}
			
			$last       = ceil( $this->_total / $this->_limit );
			
			$start      = ( ( $this->_page - $numOflinks ) > 0 ) ? $this->_page - $numOflinks : 1;
			$end        = ( ( $this->_page + $numOflinks ) < $last ) ? $this->_page + $numOflinks : $last;
			
			$html       = '<ul class="' . $list_class . '">';
			
			$class      = ( $this->_page == 1 ) ? "disabled" : "";
			$html       .= '<li class="' . $class . '">';
			$html		.= ($class != 'disabled') ? '<a href="'.$URL.'page=' . ( $this->_page - 1 ) . '">&laquo;</a></li>' : '&laquo;';
			
			if ( $start > 1 ) {
				$html   .= '<li><a href="'.$URL.'page=1">1</a></li>';
				$html   .= '<li><span>...</span></li>';
			}
			
			for ( $i = $start ; $i <= $end; $i++ ) {
				$class  = ( $this->_page == $i ) ? "active" : "";
				$html   .= '<li class="' . $class . '">';
				$html	.= ($class != 'active') ? '<a href="'.$URL.'page=' . $i . '">' . $i . '</a></li>' : $i;
			}
			
			if ( $end < $last ) {
				$html   .= '<li><span>...</span></li>';
				$html   .= '<li><a href="'.$URL.'page=' . $last . '">' . $last . '</a></li>';
			}
			
			$class      = ( $this->_page == $last ) ? "disabled" : "";
			$html       .= '<li class="' . $class . '">';
			$html 		.= ($class != 'disabled') ? '<a href="'.$URL.'&page=' . ( $this->_page + 1 ) . '">&raquo;</a>' : '&raquo;';
			$html       .= '</li>';
			$html		.= '<li><a class="all" href="'.$URL.'&page=' . ( $this->_page + 1 ) . '&limit=all">All</a></li>';
			$html		.= '<li class="page_results">'. $this->_total . ' results</li>';
			$html       .= '</ul>';
		
			return $html;
		}
	}