<?php
	ob_start(); 
	
	if(!empty($_REQUEST['debug'])){
		print_r('debug turned on');
		error_reporting(E_ALL);
		ini_set("display_errors", 1);
	}
	
	require_once('core/libraries/core.php');
	require_once('core/libraries/Import.class.php');
	require_once('core/libraries/Pagination.class.php');
	require_once('core/libraries/PHPExcel/Classes/PHPExcel/IOFactory.php');
	require_once('core/settings.php');
	
	$obj = new Core($_dbSettings, $_settings);
	
	$circuit = '';
	if(!empty($_REQUEST['circuit'])){ $circuit = $_REQUEST['circuit']; }
	
	$errormessage = '';
	$successmessage = '';
	$infomessage = '';
	$warningmessage = '';
	
	if (!is_writable(session_save_path())) {
	    $errormessage .= '<li>Session path "'.session_save_path().'" is not writable for PHP!</li>'; 
	}
	
	session_start();
	
	//check if db is installed
	try{
		$validDB = $obj->executeSQL('Select * FROM `'.$obj->settings['tablePrefix'].'Users` ');
	}
	catch(Exception $e){
		$circuit = 'install';
	}
	
	if( strpos($circuit,'install') === false ){
		if(empty($validDB)){ header("Location: install"); }
	}
	
	//check if user is logged in but webaccess / cosign requires SSL
	if( (!isset($_SERVER['REMOTE_USER']) || $_SERVER['REMOTE_USER'] === '' ) && $_SERVER['HTTPS'] != 'on'){
		#$redirect = "https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
    #header("Location: $redirect");
		#exit();
	}
	else{
		if( strpos($circuit,'install') === false )
		{
			//Grab existing users info
			$obj->currentUser();
			if(empty($obj->user)){
				$circuit = 'Access Denied';
			}
		}
		else
		{
			//If it's not empty, we only have the first user REINSTALL the app. (keyword this is for reinstalling only. how do we know? because table exists -- see $v.)
			if(!empty($validDB))
			{
				$obj->currentUser();
				if(  !empty($obj->user) && ($obj->user->uid != $validDB[0]->uid)  ){
					$circuit = 'Access Denied';
				}
			}
		}
	}
	
	$head_title = 'Cerebro';
	switch($circuit){
		case strpos($circuit,'dashboard') !== false:
			$head_title .= ' - Dashboard';
			break;
		case strpos($circuit,'install') !== false:
			$head_title .= ' - Install';
			break;
		case strpos($circuit,'events') !== false:
			$head_title .= ' - Events';
			break;
		case strpos($circuit,'venues') !== false:
			$head_title .= ' - Venues';
			if(!empty($_REQUEST['act']) && $_REQUEST['act'] == 'seats' ){
				$head_title .= ' &gt; Seats';
			}
			break;
		case strpos($circuit,'majors') !== false:
			$head_title .= ' - Majors/Minors';
			break;
		case strpos($circuit,'campuses') !== false:
			$head_title .= ' - Units';
			break;
		case strpos($circuit,'degrees') !== false:
			$head_title .= ' - Degrees';
			break;
		case strpos($circuit,'users') !== false:
			$head_title .= ' - Users';
			break;
		default:
			$head_title .= '';
			break;
	}
	if(!empty($_REQUEST['act']) && $_REQUEST['act'] == 'edit' ){
		if(!empty($_REQUEST['id'])){
			$head_title .= ' &gt; Edit';
		}
		else{
			$head_title .= ' &gt; Add';
		}
	}
?>
<?php include 'core/include/header.php'; ?>

<div id="content">
	<div class="contentPadding">
		<?php
			echo '<h1 class="nodehead">'. str_replace('Cerebro - ','',$head_title) .'</h1>';
			include 'core/include/messages.php';
			switch($circuit){
				case strpos($circuit,'dashboard') !== false:
					include 'core/include/dashboard.php';
					break;
				case strpos($circuit,'install') !== false:
					include 'core/include/install.php';
					break;
				case strpos($circuit,'events') !== false:
					include 'core/include/events.php';
					break;
				case strpos($circuit,'venues') !== false:
					include 'core/include/venues.php';
					break;
				case strpos($circuit,'majors') !== false:
					include 'core/include/majors.php';
					break;
				case strpos($circuit,'campuses') !== false:
					include 'core/include/campuses.php';
					break;
				case strpos($circuit,'degrees') !== false:
					include 'core/include/degrees.php';
					break;
				case strpos($circuit,'users') !== false:
					include 'core/include/users.php';
					break;
				case strpos($circuit,'Access Denied') !== false:
					echo 'You do not have permission to use this application.  Please contact your web developer <a href="mailto:'. $obj->settings['developerEmail'].'">'. $obj->settings['developerName'].'</a> to grant you access.';
					break;
				default:
					include 'core/include/404.php';
					break;
			}
		?>		
	</div>
</div>

<?php 
	include 'core/include/footer.php';
	ob_end_flush();
?>
