<?php
	ob_start(); 

	if(!empty($_REQUEST['debug'])){
		error_reporting(E_ALL);
		ini_set("display_errors", 1);
	}

	require_once('core/libraries/core.php');
	require_once('core/libraries/Pagination.class.php');
	require_once('core/settings.php');
	
	$obj = new Core($_dbSettings, $_settings);
	
	if(!empty($validDB))
	{
		echo 'Application not installed.  Please contact webmaster.';
		exit();
	}
	
	$circuit = 'registration';
	if(!empty($_REQUEST['circuit'])){ $circuit = $_REQUEST['circuit']; }
	
	$errormessage = '';
	$successmessage = '';
	$infomessage = '';
	$warningmessage = '';
	
	if (!is_writable(session_save_path())) {
	    $errormessage .= '<li>Session path "'.session_save_path().'" is not writable for PHP!</li>'; 
	}
	
	session_start();
	
	//check if db is installed
	$validDB = $obj->executeSQL('Select * FROM `'.$obj->settings['tablePrefix'].'Users` ');
	if(empty($validDB)){
		$circuit =  'Access Denied';
	}
	
	/*
	 * Get ID of the event
	 */
	// This is a forced ID.  To be honest, we don't need this.
	if(!empty($_REQUEST['id'])){
		$i=0;$arr=null;
		$arr[$i]['parameter'] = ':eid';
		$arr[$i]['value'] = (int)$_REQUEST['id'];
		$arr[$i]['data_type'] = PDO::PARAM_INT;
		$i++;
		$getEvents = $obj->executeSQL('Select e.*, v.name as venueName FROM `'.$obj->settings['tablePrefix'].'Events` e JOIN `'.$obj->settings['tablePrefix'].'Venues` v ON v.vid = e.vid WHERE eid = :eid ', $arr);
	}
	else{
		$getEvents = $obj->executeSQL('Select e.*, v.name as venueName FROM `'.$obj->settings['tablePrefix'].'Events` e JOIN `'.$obj->settings['tablePrefix'].'Venues` v ON v.vid = e.vid WHERE e.registerStartDateTime < now() AND e.registerEndDateTime > now() AND e.active = 1 ORDER BY e.registerStartDateTime ASC LIMIT 1 ');
	}
	if(count($getEvents)==0){
		$circuit='Event Not Found';
		$getLastEvent = $obj->executeSQL('Select e.templateContentHeader, e.templateContentFooter FROM `'.$obj->settings['tablePrefix'].'Events` e ORDER BY e.eid DESC LIMIT 1 ');
		if(count($getLastEvent)!=0){
			$header_html=$getLastEvent[0]->templateContentHeader;
			$footer_html=$getLastEvent[0]->templateContentFooter;
		}
		else{
			$header_html='<div style="background-color:#6ec8ea"><img src="https://harrisburg.psu.edu/sites/default/files/styles/header_logo_desktop/public/logos/psu_hbo_rgb_2c_3x_1.png" alt="Penn State Harrisburg mark" title="Penn State Harrisburg mark"></div>';
			$footer_html='<div></div>';
		}
	}
	else{
		$getEvents=$getEvents[0];
		$header_html=$getEvents->templateContentHeader;
		$footer_html=$getEvents->templateContentFooter;
	}
	
	$head_title = '';
	switch($circuit){
		case strpos($circuit,'registration') !== false:
			$head_title .= $getEvents->name;
			break;
		default:
			$head_title .= '';
			break;
	}

	//check if user is logged in but webaccess / cosign requires SSL
	if (isset($_GET['accessid'])) {
		if(!empty($getEvents)) {
			$getStudent = $obj->getStudentByAccessId(base64_decode(urldecode($_GET['accessid'])), $getEvents->eid);
		}
	}
	else {
		if( (!isset($_SERVER['REMOTE_USER']) || $_SERVER['REMOTE_USER'] === '' ) && $_SERVER['HTTPS'] != 'on'){
			$redirect = "https://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
			header("Location: $redirect");
			exit();
		}
		//STUDENT QUERY
		if(!empty($getEvents)) {
			$getStudent = $obj->getStudents($getEvents->eid);
		}
	}
	
	if(!empty($getStudent)==0){
		if($circuit != 'Event Not Found') {
			$circuit = 'Access Denied';
		}
	}
	else{
		$Student = $getStudent[0];
	}
?>
<?php print_r($header_html); ?>
<div id="content">
	<div class="contentPadding preface-layout">
		<?php
			echo '<h1 class="nodehead">Commencement Ceremony RSVP Form - '. $head_title .'</h1>';
			include 'core/include/messages.php';
			switch($circuit){
				case strpos($circuit,'registration') !== false:
					include $_settings['templatesDir'] . '/form/' . $getEvents->templateRegister . '/index.php';
					break;
				case strpos($circuit,'Access Denied') !== false:
					echo 'Logged in as <b>' . (string)$_SERVER['REMOTE_USER'] . '</b>. <a href="' . $obj->renderLogoutLink($_settings['landingPage']) . '">Not you?</a></h2>';
					echo '<h3>We did not find your records. Please contact the Registrar\'s Office at <a href="mailto:hbgregistrar@psu.edu">hbgregistrar@psu.edu</a>.</h3>';
					echo 'Is this a public computer? Please logout for your security. <a href="' . $obj->renderLogoutLink($_settings['landingPage']) . '">Click here to Logout</a></h2>';
					break;
				case strpos($circuit,'Event Not Found') !== false:
					echo '<h3>Registration not found or not yet active. Please come back at a later time or please visit our <a href="/">homepage</a> and search our commencement page.</h3>';
					break;
				default:
					include $_settings['templatesDir'] . '/404.php';
					break;
			}
		?>		
	</div>
</div>
<?php print_r($footer_html); ?>
<?php 
	ob_end_flush();
?>
